/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: mdr.c,v 1.9 2003/03/28 13:20:18 erik Rel $";
#endif
#include <stdlib.h>
#include <assert.h>
#include "util.h"
#include "machine/if1.h"
#include "fileio/mdr.h"
typedef struct _mdrSector{uns8 hdflag;uns8 hdnumb;char dummy1[2];char hdname[10];uns8 hdchk;uns8 recflg;uns8 recnum;uns8 reclen[2];char recnam[10];uns8 deschk;uns8 data[512];uns8 dchk;}mdrSector;typedef struct _mdrImage{mdrSector sector[CARTRIDGE_SECNUM];uns8 writeprot;}mdrImage;Cartridge*MdrOpen(const char*filename){Cartridge*cp;assert(sizeof(mdrSector)==CARTRIDGE_SECSIZE);assert(sizeof(mdrImage)==CARTRIDGE_SIZE);cp=Malloc(sizeof(Cartridge),"MdrOpen");cp->readonly=0;if((cp->mmp=(uns8*)Mmap(filename,1,&cp->readonly,&cp->mmsize))!=(uns8*)-1){if(cp->mmsize==CARTRIDGE_SIZE){cp->filename=filename;if(((mdrImage*)(cp->mmp))->writeprot==1){cp->readonly=1;}return cp;}Msg(M_WARN,"invalid cartridge image");Munmap(cp->mmp,cp->mmsize);free(cp);}return(Cartridge*)0;}
