/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_MACHINE_MACHINE_H
#define _XZX_MACHINE_MACHINE_H
typedef struct _machineTrap{int page;unsigned int addr;}MachineTrap;typedef struct _machineSettings{const char*name;int basicRom;unsigned int tvLines;unsigned int tstatesPerLine;unsigned int tstatesPerFrame;unsigned int intLine;unsigned int topBorder;unsigned char*ulaDelay;struct{MachineTrap load;MachineTrap save;
#ifndef SOUND_NATIVE
MachineTrap beep;
#endif
}traps;void(*reset)(void);void(*nmi)(void);uns8(*readOpcode)(uns16);uns8(*readMem)(uns16);void(*writeMem)(uns16,uns8);uns8(*inPort)(uns16);void(*outPort)(uns16,uns8);void(*initPages)(void);void(*pageIn)(int,int);}MachineSettings;typedef enum{SP_48_2,SP_48_3,SP_128,SP_3,
#ifdef XZX_PENTAGON
SP_PENTAGON,
#endif
#ifdef XZX_SCORPION
SP_SCORPION,
#endif
#ifdef XZX_DIDAKTIK
SP_DIDAKTIK,
#endif
NMACHINES}MachineId;extern void MachineInit(void);extern void MachineSelect(int,int);extern MachineSettings Machines[NMACHINES],*Machine;
#endif 

