/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: mem.c,v 4.43 2003/03/10 11:42:33 erik Rel $";
#endif
#include <stdio.h>
#include "util.h"
#include "machine/mem.h"
int RealPageNumbers[8];uns8*TheMemory[8];uns8*RealMemory[NPAGES];void MemoryInit(void){int i;uns8*mp=Malloc(sizeof(uns8)*(size_t)(XZX_PAGESIZE*NPAGES),"MemoryInit");for(i=0;i<NPAGES;i++,mp+=XZX_PAGESIZE){RealMemory[i]=mp;}}int LoadRomImage(const char*image,int page,int num){FILE*ifp;size_t nread;if((ifp=Fopen(image,"rb"))==(FILE*)0){Msg(M_PERR,"couldn't open ROM image <%s> for reading",image);return-1;}while(num--){nread=fread(RealMemory[page++],1,XZX_PAGESIZE,ifp);if(nread!=XZX_PAGESIZE&&nread!=XZX_PAGESIZE/2){Msg(M_WARN,"ROM image <%s> is too short",image);break;}}(void)fclose(ifp);return 0;}int GetRomChecksum(int rom,int length){int checksum=0,tmp,i;for(i=0;i<length;i++){tmp=checksum&0x01;checksum>>=1;if(tmp){checksum|=0x8000;}checksum^=RealMemory[rom][i];}return checksum;}
