/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char beep_c[]="$Id: beep.c,v 4.29 2003/03/06 20:24:27 erik Rel $";
#endif
#include <X11/Xlib.h>
#include "z80/z80.h"
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "machine/machine.h"
#include "ui/xwin.h"
#include "sound/beep.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
int BeepCheckTrap(int page,unsigned int addr){if(addr==Machine->traps.beep.addr&&page==Machine->traps.beep.page){if((CFGGET(sound)>0&&CFGGET(soundVolume)>0)||CFGGET(fastmode)==0){XKeyboardState kbs,oldKbs;unsigned int freq=1750000/((HL+30)<<2);unsigned int duration=(1000*DE)/freq;DEB(Msg(M_DEBUG,"BEEP: freq = %d Hz, time = %d ms",freq,duration););XGetKeyboardControl(XwinDataP->display,&oldKbs);kbs.bell_pitch=freq;kbs.bell_duration=duration;kbs.bell_percent=CFGGET(soundVolume);
#define KBELL_MASK (KBBellPitch | KBBellDuration | KBBellPercent)
XChangeKeyboardControl(XwinDataP->display,KBELL_MASK,(XKeyboardControl*)&kbs);XBell(XwinDataP->display,0);XChangeKeyboardControl(XwinDataP->display,KBELL_MASK,(XKeyboardControl*)&oldKbs);
#undef KBELL_MASK
XFlush(XwinDataP->display);return 1;}}return 0;}
